Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class AbstractSet

    java.lang.Object
      |
      +--java.util.AbstractCollection
            |
            +--java.util.AbstractSet

All Implemented Interfaces:
  Collection, Set

Direct Known Subclasses:
  HashSet, TreeSet

public abstract class AbstractSet
extends AbstractCollection
implements Set

This class provides a skeletal implementation of the `Set` interface to minimize the effort required to implement this interface.

The process of implementing a set by extending this class is identical to that of implementing a Collection by extending AbstractCollection, except that all of the methods and constructors in subclasses of this class must obey the additional constraints imposed by the `Set` interface (for instance, the add method must not permit addition of multiple intances of an object to a set).

Note that this class does not override any of the implementations from the `AbstractCollection` class. It merely adds implementations for `equals` and `hashCode`.

Since:
  1.2
See Also:
  `Collection`, `AbstractCollection`, `Set`

Constructor Summary
`protected` | `AbstractSet()` Sole constructor.

Method Summary
`boolean` | `equals(Object o)` Compares the specified object with this set for equality.
`int` | `hashCode()` Returns the hash code value for this set.
`boolean` | `removeAll(Collection c)` Removes from this set all of its elements that are contained in the specified collection (optional operation).

Methods inherited from class java.util.AbstractCollection
`add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Set
`add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, retainAll, size, toArray, toArray`

Constructor Detail

### AbstractSet

    protected AbstractSet()

  Sole constructor. (For invocation by subclass constructors, typically implicit.)

Method Detail

### equals

    public boolean equals(Object o)

  Compares the specified object with this set for equality. Returns `true` if the given object is also a set, the two sets have the same size, and every member of the given set is contained in this set. This ensures that the `equals` method works properly across different implementations of the `Set` interface.

  This implementation first checks if the specified object is this set; if so it returns `true`. Then, it checks if the specified object is a set whose size is identical to the size of this set; if not, it it returns false. If so, it returns `containsAll((Collection) o)`.

  Specified by:
    `equals` in interface `Set`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `o` - Object to be compared for equality with this set.
  Returns:
    `true` if the specified object is equal to this set.

### hashCode

    public int hashCode()

  Returns the hash code value for this set. The hash code of a set is defined to be the sum of the hash codes of the elements in the set. This ensures that `s1.equals(s2)` implies that `s1.hashCode()==s2.hashCode()` for any two sets `s1` and `s2`, as required by the general contract of Object.hashCode.

  This implementation enumerates over the set, calling the `hashCode` method on each element in the collection, and adding up the results.

  Specified by:
    `hashCode` in interface `Set`
  Overrides:
    `hashCode` in class `Object`
  Returns:
    the hash code value for this set.

### removeAll

    public boolean removeAll(Collection c)

  Removes from this set all of its elements that are contained in the specified collection (optional operation).

  This implementation determines which is the smaller of this set and the specified collection, by invoking the `size` method on each. If this set has fewer elements, then the implementation iterates over this set, checking each element returned by the iterator in turn to see if it is contained in the specified collection. If it is so contained, it is removed from this set with the iterator's `remove` method. If the specified collection has fewer elements, then the implementation iterates over the specified collection, removing from this set each element returned by the iterator, using this set's `remove` method.

  Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by the `iterator` method does not implement the `remove` method.

  Specified by:
    `removeAll` in interface `Set`
  Overrides:
    `removeAll` in class `AbstractCollection`
  Parameters:
    `c` - elements to be removed from this set.
  Returns:
    `true` if this set changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - removeAll is not supported by this set.
  See Also:
    `AbstractCollection.remove(Object)`, `AbstractCollection.contains(Object)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.